#include <limits.h>
#include <vcc.h>

unsigned int bin_search(unsigned int a [], unsigned int a_len, unsigned int key)
  _(requires \thread_local_array(a, a_len))
  _(requires \forall unsigned int i, j; i < j && j < a_len ==> a[i] <= a[j]) 
  _(ensures \result != UINT_MAX ==> a[\result] == key)                
  _(ensures \result == UINT_MAX ==> \forall unsigned int i; i < a_len ==> a[i] !=  key) 
{
    
  unsigned int lo= 0;
  unsigned int hi= a_len;
  unsigned int mid;
  
  while (lo <= hi) 
    _(invariant hi <= a_len)
    _(invariant \forall unsigned int i; i < lo ==> a[i] <  key) 
    _(invariant \forall unsigned int i; hi <= i && i < a_len ==>a[i] >= key) 
    {
      mid= (lo+ hi)/2;
      if (a[mid] < key) lo= mid+1;
      else hi= mid;
    }
   
  if (!(lo < a_len && a[lo] == key)) lo= UINT_MAX;
  
  return lo;
  
}
